Plack::App::URLMap(3)

NAME
Plack::App::URLMap - Map multiple apps in different paths

SYNOPSIS
  use Plack::App::URLMap;

  my $app1 = sub { ... };
  my $app2 = sub { ... };
  my $app3 = sub { ... };

  my $urlmap = Plack::App::URLMap->new;
  $urlmap->map("/" => $app1);
  $urlmap->map("/foo" => $app2);
  $urlmap->map("http://bar.example.com/" => $app3);

  my $app = $urlmap->to_app;

DESCRIPTION
Plack::App::URLMap is a PSGI application that can dispatch multiple applications based on URL path and hostnames (a.k.a "virtual hosting") and takes care of rewriting "SCRIPT_NAME" and "PATH_INFO". This module is inspired by Rack::URLMap.

METHODS

map
      $urlmap->map("/foo" => $app);
      $urlmap->map("http://bar.example.com/" => $another_app);

    Maps URL path or an absolute URL to a PSGI application. The match order is sorted by host name length and then path length.

    URL paths need to match from the beginning and should match completely till the path separator (or the end of the path). For example, if you register the path "/foo", it will match with the request "/foo", "/foo/" or "/foo/bar" but it won't match with "/foox".

    Mapping URL with host names is also possible, and in that case the URL mapping works like a virtual host.

mount
    Alias for "map".

to_app
      my $handler = $urlmap->to_app;

    Returns the PSGI application code reference. Note that the Plack::App::URLMap object is callable (by overloading the code dereference), so returning the object itself as a PSGI application should also work.

AUTHOR
Tatsuhiko Miyagawa

SEE ALSO
Plack::Builder